import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.github.bohnman.squiggly.Squiggly;
import com.github.bohnman.squiggly.util.SquigglyUtils;

import java.io.IOException;
import java.util.Date;
import java.util.UUID;

public class squigglyTest {
    private ObjectMapper squigglyObjectMapper;
    private MyObject myObject;

    public void setUp() throws IOException {
        myObject = new MyObject();
        myObject.setId(UUID.randomUUID());
        myObject.setRequestedDate(new Date());
        myObject.setDetails(new Details());
        myObject.getDetails().setAddress(new Address());
        myObject.getDetails().getAddress().setAddressLine1("East Streen");
        myObject.getDetails().getAddress().setAddressLine2("line2 address");
        myObject.getDetails().getAddress().setRegion("region");
        myObject.getDetails().getAddress().setCity("London");
        myObject.getDetails().getAddress().setPostalCode("E32TD");
        myObject.getDetails().getAddress().setCountry("GB");
    }

    public static void main(String... args) throws Exception {
        squigglyTest squigglyTest = new squigglyTest();
        squigglyTest.setUp();
        String filter = "id,details";
        squigglyTest.squigglyObjectMapper = Squiggly.init(new ObjectMapper(), filter);
        System.out.print(SquigglyUtils.stringify(squigglyTest.squigglyObjectMapper, squigglyTest.myObject));
    }

    private class MyObject {
        Details details;
        private UUID id;
        private Date requestedDate;

        @JsonProperty("id")
        public UUID getId() {
            return id;
        }

        public void setId(UUID id) {
            this.id = id;
        }

        @JsonProperty("details")
        public Details getDetails() {
            return details;
        }

        public void setDetails(Details details) {
            this.details = details;
        }

        @JsonProperty("requested_at")
        @JsonFormat(
                pattern = "yyyy-MM-dd'T'HH:mm:ss.SSS'Z'"
        )
        public Date getRequestedDate() {
            return requestedDate;
        }

        public void setRequestedDate(Date requestedDate) {
            this.requestedDate = requestedDate;
        }
    }

    private class Details {
        private Address address;

        @JsonProperty("address")
        public Address getAddress() {
            return address;
        }

        public void setAddress(Address address) {
            this.address = address;
        }
    }

    private class Address {
        private String company;
        private String addressLine1;
        private String addressLine2;
        private String addressLine3;
        private String region;
        private String city;
        private String postalCode;
        private String country;

        @JsonProperty("company")
        public String getCompany() {
            return company;
        }

        public void setCompany(String company) {
            this.company = company;
        }

        @JsonProperty("line_1")
        public String getAddressLine1() {
            return addressLine1;
        }

        public void setAddressLine1(String addressLine1) {
            this.addressLine1 = addressLine1;
        }

        @JsonProperty("line_2")
        public String getAddressLine2() {
            return addressLine2;
        }

        public void setAddressLine2(String addressLine2) {
            this.addressLine2 = addressLine2;
        }

        @JsonProperty("line_3")
        public String getAddressLine3() {
            return addressLine3;
        }

        public void setAddressLine3(String addressLine3) {
            this.addressLine3 = addressLine3;
        }

        @JsonProperty("region")
        public String getRegion() {
            return region;
        }

        public void setRegion(String region) {
            this.region = region;
        }

        @JsonProperty("city")
        public String getCity() {
            return city;
        }

        public void setCity(String city) {
            this.city = city;
        }

        @JsonProperty("postal_code")
        public String getPostalCode() {
            return postalCode;
        }

        public void setPostalCode(String postalCode) {
            this.postalCode = postalCode;
        }

        @JsonProperty("country")
        public String getCountry() {
            return country;
        }

        public void setCountry(String country) {
            this.country = country;
        }
    }
}